/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.mode;

import java.util.Map;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.simnml.instruction.AddressingMode;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class RRX extends AddressingMode
{
    public static final String NAME = "RRX";

    public static final ParamDecl[] PARAMS = new ParamDecl[]
    {
        new ParamDecl("r", index)
    };

    public static final IFactory FACTORY = new IFactory()
    {
        @Override
        public IAddressingMode create(Map<String, Data> args)
        {
            return new RRX(args);
        }
    };

    public static final Map<String, Type> DECLS = createDeclarations(PARAMS);
    public static final IInfo INFO = new Info(RRX.class, NAME, FACTORY, DECLS);

    private final Location r;

    public RRX(Map<String, Data> args)
    {
        this.r = getArgument("r", DECLS, args);
    }

    @Override
    public String syntax()
    {
        return String.format("R%d , RRX ", r.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("00000110%4b", r.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        shifter_carry_out.access().store(GPR.access(DataEngine.intValue(r.load())).bitField(0, 0).load());
    }

    @Override
    public Location access()
    {
        return new Location(DataEngine.intValue(r.load()) == 15 ? DataEngine.execute(EOperatorID.BIT_OR, DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(new Type(ETypeID.CARD, 32), CPSR.access().bitField(29, 29).load()), DataEngine.valueOf(new Type(ETypeID.CARD, 32), 31)), DataEngine.execute(EOperatorID.R_SHIFT, DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.valueOf(word, 4)), DataEngine.valueOf(word, 1))) : DataEngine.execute(EOperatorID.BIT_OR, DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(new Type(ETypeID.CARD, 32), CPSR.access().bitField(29, 29).load()), DataEngine.valueOf(new Type(ETypeID.CARD, 32), 31)), DataEngine.execute(EOperatorID.R_SHIFT, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.valueOf(word, 1))));
    }
}
 