/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class ADD_IMMEDIATE extends Operation
{
    public static final String NAME = "ADD_IMMEDIATE";

    public static final IInfo INFO = new Info(ADD_IMMEDIATE.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode sets;
    private final IAddressingMode src1;
    private final IAddressingMode src2;
    private final IAddressingMode src3;

    public ADD_IMMEDIATE(IAddressingMode cond, IAddressingMode sets, IAddressingMode src1, IAddressingMode src2, IAddressingMode src3)
    {
        assert Condition.INFO.isSupported(cond);
        assert setS.INFO.isSupported(sets);
        assert REG.INFO.isSupported(src1);
        assert REG.INFO.isSupported(src2);
        assert IMMEDIATE.INFO.isSupported(src3);

        this.cond = cond;
        this.sets = sets;
        this.src1 = src1;
        this.src2 = src2;
        this.src3 = src3;
    }

    @Override
    public String syntax()
    {
        return String.format("ADD%s%s %s, %s, %s", cond.syntax(), sets.syntax(), src1.syntax(), src2.syntax(), src3.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s0010100%s%s%s%s", cond.image(), sets.image(), src2.image(), src1.image(), src3.image());
    }

    @Override
    public void action()
    {
        cond.action();
        src3.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            Location.concat(ALU_OUT.access(), carry.access()).store(DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(src2.access().load())).load(), src3.access().load()));
            if (DataEngine.intValue(sets.access().load()) == 1 && DataEngine.intValue(src1.access().load()) == 15)
            {
                CPSR.access().store(SPSR.access().load());
            }
            else
            {
                if (DataEngine.intValue(sets.access().load()) == 1)
                {
                    CPSR.access().bitField(31, 31).store(ALU_OUT.access().bitField(31, 31).load());
                    if (DataEngine.intValue(ALU_OUT.access().load()) == 0)
                    {
                        CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
                    }
                    else
                    {
                        CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
                    }
                    CPSR.access().bitField(29, 29).store(carry.access().load());
                    if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.EQ, GPR.access(DataEngine.intValue(src2.access().load())).bitField(31, 31).load(), src3.access().bitField(31, 31).load())) && DataEngine.booleanValue(DataEngine.execute(EOperatorID.NOT_EQ, ALU_OUT.access().bitField(31, 31).load(), GPR.access(DataEngine.intValue(src2.access().load())).bitField(31, 31).load())))
                    {
                        CPSR.access().bitField(28, 28).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
                    }
                    else
                    {
                        CPSR.access().bitField(28, 28).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0));
                    }
                }
            }
            GPR.access(DataEngine.intValue(src1.access().load())).store(ALU_OUT.access().load());
        }
    }
}
