/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class CLZ extends Operation
{
    public static final String NAME = "CLZ";

    public static final IInfo INFO = new Info(CLZ.class, NAME);

    private final IAddressingMode cond;
    private final Location rd;
    private final Location rm;

    public CLZ(IAddressingMode cond, Location rd, Location rm)
    {
        assert Condition.INFO.isSupported(cond);
        assert index.equals(rd.getType());
        assert index.equals(rm.getType());

        this.cond = cond;
        this.rd = rd;
        this.rm = rm;
    }

    @Override
    public String syntax()
    {
        return String.format("CLZ%s R%d,R%d", cond.syntax(), rd.load().getRawData().intValue(), rm.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s000101100000%4b00000001%4b", cond.image(), rd.load().getRawData().toBinString(), rm.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).load()) == 0)
            {
                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 32));
            }
            else
            {
                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(31, 31).load()) == 1)
                {
                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 31 - 31));
                }
                else
                {
                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(30, 30).load()) == 1)
                    {
                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 31 - 30));
                    }
                    else
                    {
                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(29, 29).load()) == 1)
                        {
                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 2), 31 - 29));
                        }
                        else
                        {
                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(28, 28).load()) == 1)
                            {
                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 2), 31 - 28));
                            }
                            else
                            {
                                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(27, 27).load()) == 1)
                                {
                                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 27));
                                }
                                else
                                {
                                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(26, 26).load()) == 1)
                                    {
                                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 26));
                                    }
                                    else
                                    {
                                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(25, 25).load()) == 1)
                                        {
                                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 25));
                                        }
                                        else
                                        {
                                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(24, 24).load()) == 1)
                                            {
                                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 24));
                                            }
                                            else
                                            {
                                                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(23, 23).load()) == 1)
                                                {
                                                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 23));
                                                }
                                                else
                                                {
                                                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(22, 22).load()) == 1)
                                                    {
                                                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 22));
                                                    }
                                                    else
                                                    {
                                                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(21, 21).load()) == 1)
                                                        {
                                                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 21));
                                                        }
                                                        else
                                                        {
                                                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(20, 20).load()) == 1)
                                                            {
                                                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 20));
                                                            }
                                                            else
                                                            {
                                                                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(19, 19).load()) == 1)
                                                                {
                                                                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 19));
                                                                }
                                                                else
                                                                {
                                                                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(18, 18).load()) == 1)
                                                                    {
                                                                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 18));
                                                                    }
                                                                    else
                                                                    {
                                                                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(17, 17).load()) == 1)
                                                                        {
                                                                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 17));
                                                                        }
                                                                        else
                                                                        {
                                                                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(16, 16).load()) == 1)
                                                                            {
                                                                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 4), 31 - 16));
                                                                            }
                                                                            else
                                                                            {
                                                                                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(15, 15).load()) == 1)
                                                                                {
                                                                                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 15));
                                                                                }
                                                                                else
                                                                                {
                                                                                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(14, 14).load()) == 1)
                                                                                    {
                                                                                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 14));
                                                                                    }
                                                                                    else
                                                                                    {
                                                                                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(13, 13).load()) == 1)
                                                                                        {
                                                                                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 13));
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(12, 12).load()) == 1)
                                                                                            {
                                                                                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 12));
                                                                                            }
                                                                                            else
                                                                                            {
                                                                                                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(11, 11).load()) == 1)
                                                                                                {
                                                                                                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 11));
                                                                                                }
                                                                                                else
                                                                                                {
                                                                                                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(10, 10).load()) == 1)
                                                                                                    {
                                                                                                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 10));
                                                                                                    }
                                                                                                    else
                                                                                                    {
                                                                                                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(9, 9).load()) == 1)
                                                                                                        {
                                                                                                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 9));
                                                                                                        }
                                                                                                        else
                                                                                                        {
                                                                                                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(8, 8).load()) == 1)
                                                                                                            {
                                                                                                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 8));
                                                                                                            }
                                                                                                            else
                                                                                                            {
                                                                                                                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(7, 7).load()) == 1)
                                                                                                                {
                                                                                                                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 7));
                                                                                                                }
                                                                                                                else
                                                                                                                {
                                                                                                                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(6, 6).load()) == 1)
                                                                                                                    {
                                                                                                                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 6));
                                                                                                                    }
                                                                                                                    else
                                                                                                                    {
                                                                                                                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(5, 5).load()) == 1)
                                                                                                                        {
                                                                                                                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 5));
                                                                                                                        }
                                                                                                                        else
                                                                                                                        {
                                                                                                                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(4, 4).load()) == 1)
                                                                                                                            {
                                                                                                                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 4));
                                                                                                                            }
                                                                                                                            else
                                                                                                                            {
                                                                                                                                if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(3, 3).load()) == 1)
                                                                                                                                {
                                                                                                                                    GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 3));
                                                                                                                                }
                                                                                                                                else
                                                                                                                                {
                                                                                                                                    if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(2, 2).load()) == 1)
                                                                                                                                    {
                                                                                                                                        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 2));
                                                                                                                                    }
                                                                                                                                    else
                                                                                                                                    {
                                                                                                                                        if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(1, 1).load()) == 1)
                                                                                                                                        {
                                                                                                                                            GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 1));
                                                                                                                                        }
                                                                                                                                        else
                                                                                                                                        {
                                                                                                                                            if (DataEngine.intValue(GPR.access(DataEngine.intValue(rm.load())).bitField(0, 0).load()) == 1)
                                                                                                                                            {
                                                                                                                                                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31 - 0));
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
