/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class CMN extends Operation
{
    public static final String NAME = "CMN";

    public static final IInfo INFO = new Info(CMN.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode src1;
    private final IAddressingMode src2;

    public CMN(IAddressingMode cond, IAddressingMode src1, IAddressingMode src2)
    {
        assert Condition.INFO.isSupported(cond);
        assert REG.INFO.isSupported(src1);
        assert DATA_PROCESSING.INFO.isSupported(src2);

        this.cond = cond;
        this.src1 = src1;
        this.src2 = src2;
    }

    @Override
    public String syntax()
    {
        return String.format("CMN%s %s, %s", cond.syntax(), src1.syntax(), src2.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s00010111%s0000%s", cond.image(), src1.image(), src2.image());
    }

    @Override
    public void action()
    {
        cond.action();
        src2.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            Location.concat(ALU_OUT.access(), carry.access()).store(DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(src1.access().load())).load(), src2.access().load()));
            CPSR.access().bitField(31, 31).store(ALU_OUT.access().bitField(31, 31).load());
            if (DataEngine.intValue(ALU_OUT.access().load()) == 0)
            {
                CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0x1));
            }
            else
            {
                CPSR.access().bitField(30, 30).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0x0));
            }
            CPSR.access().bitField(29, 29).store(carry.access().load());
            if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.EQ, GPR.access(DataEngine.intValue(src1.access().load())).bitField(31, 31).load(), src2.access().bitField(31, 31).load())) && DataEngine.booleanValue(DataEngine.execute(EOperatorID.NOT_EQ, ALU_OUT.access().bitField(31, 31).load(), GPR.access(DataEngine.intValue(src1.access().load())).bitField(31, 31).load())))
            {
                CPSR.access().bitField(28, 28).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0x1));
            }
            else
            {
                CPSR.access().bitField(28, 28).store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 0x0));
            }
        }
    }
}
