/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class LDR_IMMEDIATE_POST_INDEXED extends Operation
{
    public static final String NAME = "LDR_IMMEDIATE_POST_INDEXED";

    public static final IInfo INFO = new Info(LDR_IMMEDIATE_POST_INDEXED.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode src1;
    private final Location r;
    private final Location offset;
    private final IAddressingMode Ubit;

    public LDR_IMMEDIATE_POST_INDEXED(IAddressingMode cond, IAddressingMode src1, Location r, Location offset, IAddressingMode Ubit)
    {
        assert Condition.INFO.isSupported(cond);
        assert REG.INFO.isSupported(src1);
        assert index.equals(r.getType());
        assert Bit12.equals(offset.getType());
        assert setU.INFO.isSupported(Ubit);

        this.cond = cond;
        this.src1 = src1;
        this.r = r;
        this.offset = offset;
        this.Ubit = Ubit;
    }

    @Override
    public String syntax()
    {
        return String.format("LDR%s %s, [ R%d ], #%s%d", cond.syntax(), src1.syntax(), r.load().getRawData().intValue(), Ubit.syntax(), offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s0100%s001%4b%s%12b", cond.image(), Ubit.image(), r.load().getRawData().toBinString(), src1.image(), offset.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        amode.access().store(GPR.access(DataEngine.intValue(r.load())).load());
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            if (DataEngine.intValue(Ubit.access().load()) == 1)
            {
                GPR.access(DataEngine.intValue(r.load())).store(DataEngine.execute(EOperatorID.PLUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.coerce(new Type(ETypeID.CARD, 32), offset.load())));
            }
            else
            {
                GPR.access(DataEngine.intValue(r.load())).store(DataEngine.execute(EOperatorID.MINUS, GPR.access(DataEngine.intValue(r.load())).load(), DataEngine.coerce(new Type(ETypeID.CARD, 32), offset.load())));
            }
        }
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            temp.access().store(Location.concat(M.access(DataEngine.intValue(amode.access().load())), M.access(DataEngine.intValue(amode.access().load()) + 1), M.access(DataEngine.intValue(amode.access().load()) + 2), M.access(DataEngine.intValue(amode.access().load()) + 3)).load());
            if (DataEngine.intValue(CP15.access(1).bitField(22, 22).load()) == 0)
            {
                GPR.access(DataEngine.intValue(src1.access().load())).store(DataEngine.execute(EOperatorID.R_ROTATE, temp.access().load(), DataEngine.coerce(word, DataEngine.execute(EOperatorID.MUL, DataEngine.valueOf(new Type(ETypeID.CARD, 2), 8), amode.access().bitField(1, 0).load()))));
            }
            else
            {
                GPR.access(DataEngine.intValue(src1.access().load())).store(temp.access().load());
            }
            if (DataEngine.intValue(src1.access().load()) == 15)
            {
                GPR.access(DataEngine.intValue(src1.access().load())).store(DataEngine.execute(EOperatorID.BIT_AND, GPR.access(DataEngine.intValue(src1.access().load())).load(), DataEngine.valueOf(word, 0xfffffffc)));
            }
        }
    }
}
