/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class SMULWy extends Operation
{
    public static final String NAME = "SMULWy";

    public static final IInfo INFO = new Info(SMULWy.class, NAME);

    private final IAddressingMode cond;
    private final Location rd;
    private final Location rs;
    private final IAddressingMode ybit;
    private final Location rm;

    public SMULWy(IAddressingMode cond, Location rd, Location rs, IAddressingMode ybit, Location rm)
    {
        assert Condition.INFO.isSupported(cond);
        assert index.equals(rd.getType());
        assert index.equals(rs.getType());
        assert setY.INFO.isSupported(ybit);
        assert index.equals(rm.getType());

        this.cond = cond;
        this.rd = rd;
        this.rs = rs;
        this.ybit = ybit;
        this.rm = rm;
    }

    @Override
    public String syntax()
    {
        return String.format("SMUL%s%s R%d, R%d, R%d", cond.syntax(), ybit.syntax(), rd.load().getRawData().intValue(), rm.load().getRawData().intValue(), rs.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%s00010010%4b0000%4b1%s10%4b", cond.image(), rd.load().getRawData().toBinString(), rs.load().getRawData().toBinString(), ybit.image(), rm.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            if (DataEngine.intValue(ybit.access().load()) == 0)
            {
                operand2.access().store(DataEngine.coerce(new Type(ETypeID.INT, 16), GPR.access(DataEngine.intValue(rs.load())).bitField(15, 0).load()));
            }
            else
            {
                operand2.access().store(DataEngine.coerce(new Type(ETypeID.INT, 16), GPR.access(DataEngine.intValue(rs.load())).bitField(31, 16).load()));
            }
            Result48.access().store(DataEngine.execute(EOperatorID.MUL, operand1.access().load(), operand2.access().load()));
            GPR.access(DataEngine.intValue(rd.load())).store(Result48.access().bitField(47, 16).load());
        }
    }
}
