/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'arm.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.arm.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.arm.mode.*;

import static ru.ispras.microtesk.model.arm.shared.Shared.*;

public final class SWP extends Operation
{
    public static final String NAME = "SWP";

    public static final IInfo INFO = new Info(SWP.class, NAME);

    private final IAddressingMode cond;
    private final IAddressingMode rn;
    private final IAddressingMode rd;
    private final IAddressingMode rm;

    public SWP(IAddressingMode cond, IAddressingMode rn, IAddressingMode rd, IAddressingMode rm)
    {
        assert Condition.INFO.isSupported(cond);
        assert REG.INFO.isSupported(rn);
        assert REG.INFO.isSupported(rd);
        assert REG.INFO.isSupported(rm);

        this.cond = cond;
        this.rn = rn;
        this.rd = rd;
        this.rm = rm;
    }

    @Override
    public String syntax()
    {
        return String.format("SWP%s %s,%s,%s", cond.syntax(), rd.syntax(), rm.syntax(), rn.syntax());
    }

    @Override
    public String image()
    {
        return String.format("%s00010000%s%s00001001%s", cond.image(), rn.image(), rd.image(), rm.image());
    }

    @Override
    public void action()
    {
        cond.action();
        if (DataEngine.intValue(X.access().load()) == 1)
        {
            amode.access().store(GPR.access(DataEngine.intValue(rn.access().load())).load());
            if (DataEngine.intValue(CP15.access(1).bitField(22, 22).load()) == 0)
            {
                temp.access().store(Location.concat(M.access(DataEngine.intValue(amode.access().load())), M.access(DataEngine.intValue(amode.access().load()) + 1), M.access(DataEngine.intValue(amode.access().load()) + 2), M.access(DataEngine.intValue(amode.access().load()) + 3)).load());
                temp1.access().store(DataEngine.execute(EOperatorID.R_ROTATE, temp.access().load(), DataEngine.coerce(word, DataEngine.execute(EOperatorID.MUL, DataEngine.valueOf(new Type(ETypeID.CARD, 2), 8), amode.access().bitField(1, 0).load()))));
                Location.concat(M.access(DataEngine.intValue(amode.access().load())), M.access(DataEngine.intValue(amode.access().load()) + 1), M.access(DataEngine.intValue(amode.access().load()) + 2), M.access(DataEngine.intValue(amode.access().load()) + 3)).store(rm.access().load());
                rd.access().store(temp1.access().load());
            }
            else
            {
                temp.access().store(Location.concat(M.access(DataEngine.intValue(amode.access().load())), M.access(DataEngine.intValue(amode.access().load()) + 1), M.access(DataEngine.intValue(amode.access().load()) + 2), M.access(DataEngine.intValue(amode.access().load()) + 3)).load());
                temp1.access().store(temp.access().load());
                Location.concat(M.access(DataEngine.intValue(amode.access().load())), M.access(DataEngine.intValue(amode.access().load()) + 1), M.access(DataEngine.intValue(amode.access().load()) + 2), M.access(DataEngine.intValue(amode.access().load()) + 3)).store(rm.access().load());
                rd.access().store(temp1.access().load());
            }
        }
    }
}
