/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.mode;

import java.util.Map;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.simnml.instruction.AddressingMode;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class IMM26 extends AddressingMode
{
    public static final String NAME = "IMM26";

    public static final ParamDecl[] PARAMS = new ParamDecl[]
    {
        new ParamDecl("n", new Type(ETypeID.INT, 26))
    };

    public static final IFactory FACTORY = new IFactory()
    {
        @Override
        public IAddressingMode create(Map<String, Data> args)
        {
            return new IMM26(args);
        }
    };

    public static final Map<String, Type> DECLS = createDeclarations(PARAMS);
    public static final IInfo INFO = new Info(IMM26.class, NAME, FACTORY, DECLS);

    private final Location n;

    public IMM26(Map<String, Data> args)
    {
        this.n = getArgument("n", DECLS, args);
    }

    @Override
    public String syntax()
    {
        return String.format("%d", n.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("%26b", n.load().getRawData().toBinString());
    }

    @Override
    public Location access()
    {
        return n;
    }
}
 