/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class ADD extends Operation
{
    public static final String NAME = "ADD";

    public static final IInfo INFO = new Info(ADD.class, NAME);

    private final Location rd;
    private final IAddressingMode rs;
    private final IAddressingMode rt;

    public ADD(Location rd, IAddressingMode rs, IAddressingMode rt)
    {
        assert index.equals(rd.getType());
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert REG_IND_ZERO.INFO.isSupported(rt);

        this.rd = rd;
        this.rs = rs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("ADD %d, %s, %s", rd.load().getRawData().intValue(), rs.syntax(), rt.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%s%s%5b00000100000", rs.image(), rt.image(), rd.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        Location.concat(tmp_unsigned_word.access(), overflow_bit.access()).store(DataEngine.execute(EOperatorID.PLUS, rs.access().load(), rt.access().load()));
        if (DataEngine.intValue(overflow_bit.access().load()) == 1)
        {
        }
        else
        {
            GPR.access(DataEngine.intValue(rd.load())).store(tmp_unsigned_word.access().load());
        }
    }
}
