/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class BGEZALL extends Operation
{
    public static final String NAME = "BGEZALL";

    public static final IInfo INFO = new Info(BGEZALL.class, NAME);

    private final IAddressingMode rs;
    private final IAddressingMode offset;

    public BGEZALL(IAddressingMode rs, IAddressingMode offset)
    {
        assert REG_IND_ZERO.INFO.isSupported(rs);
        assert IMM16.INFO.isSupported(offset);

        this.rs = rs;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("BGEZ %s, %s", rs.syntax(), offset.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000001%s10011%s", rs.image(), offset.image());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(rs.access().load()) >= 0)
        {
            branch.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
            tmp_signed_word.access().store(offset.access().load());
            tmp_signed_word.access().store(DataEngine.execute(EOperatorID.L_SHIFT, tmp_signed_word.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 32), 2)));
            JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.coerce(new Type(ETypeID.INT, 32), NIA.access().load()), tmp_signed_word.access().load()));
            GPR.access(31).store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(long_t, 8)));
        }
    }
}
