/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class CLZ extends Operation
{
    public static final String NAME = "CLZ";

    public static final IInfo INFO = new Info(CLZ.class, NAME);

    private final Location rd;
    private final IAddressingMode rs;

    public CLZ(Location rd, IAddressingMode rs)
    {
        assert index.equals(rd.getType());
        assert REG_IND_ZERO.INFO.isSupported(rs);

        this.rd = rd;
        this.rs = rs;
    }

    @Override
    public String syntax()
    {
        return String.format("CLZ %d,%s", rd.load().getRawData().intValue(), rs.syntax());
    }

    @Override
    public String image()
    {
        return String.format("011100%s%5b%5b00000100000", rs.image(), rd.load().getRawData().toBinString(), rd.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        tmp_signed_byte.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 31));
        GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.valueOf(new Type(ETypeID.INT, 8), 32));
        loop();
    }

    public void loop()
    {
        if (DataEngine.intValue(tmp_signed_byte.access().load()) >= 0)
        {
            if (DataEngine.intValue(rs.access().bitField(DataEngine.intValue(tmp_signed_byte.access().load()), DataEngine.intValue(tmp_signed_byte.access().load())).load()) == 0)
            {
                tmp_signed_byte.access().store(DataEngine.execute(EOperatorID.MINUS, tmp_signed_byte.access().load(), DataEngine.valueOf(new Type(ETypeID.INT, 8), 1)));
            }
            else
            {
                GPR.access(DataEngine.intValue(rd.load())).store(DataEngine.execute(EOperatorID.MINUS, DataEngine.valueOf(new Type(ETypeID.INT, 8), 31), tmp_signed_byte.access().load()));
                tmp_signed_byte.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 32), -1));
            }
            loop();
        }
    }
}
