/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.simnml.instruction.IAddressingMode;
import ru.ispras.microtesk.model.mips.mode.*;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class JALR extends Operation
{
    public static final String NAME = "JALR";

    public static final IInfo INFO = new Info(JALR.class, NAME);

    private final IAddressingMode rs;

    public JALR(IAddressingMode rs)
    {
        assert REG_IND_ZERO.INFO.isSupported(rs);

        this.rs = rs;
    }

    @Override
    public String syntax()
    {
        return String.format("JALR %s", rs.syntax());
    }

    @Override
    public String image()
    {
        return String.format("000000%s000001111100000001001", rs.image());
    }

    @Override
    public void action()
    {
        branch.access().store(DataEngine.valueOf(new Type(ETypeID.INT, 1), 1));
        CIA.access().store(NIA.access().load());
        JMPADDR.access().store(rs.access().load());
        GPR.access(31).store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(long_t, 4)));
    }
}
