/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'mips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips.op;

import ru.ispras.microtesk.model.api.simnml.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.mips.shared.Shared.*;

public final class MFLO extends Operation
{
    public static final String NAME = "MFLO";

    public static final IInfo INFO = new Info(MFLO.class, NAME);

    private final Location rd;

    public MFLO(Location rd)
    {
        assert index.equals(rd.getType());

        this.rd = rd;
    }

    @Override
    public String syntax()
    {
        return String.format("MFLO %d", rd.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("0000000000000000%5b00000010010", rd.load().getRawData().toBinString());
    }

    @Override
    public void action()
    {
        GPR.access(DataEngine.intValue(rd.load())).store(LO.access().load());
    }
}
